﻿Type=Activity
Version=3.2
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: True
	#IncludeTitle: False
#End Region

 'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim MaxNumLength = 3 As Int
	Dim DecimalUsed = False As Boolean

End Sub

Sub Globals

	Dim Button0 As Button
	Dim Button1 As Button
	Dim Button2 As Button
	Dim Button3 As Button
	Dim Button4 As Button
	Dim Button5 As Button
	Dim Button6 As Button
	Dim Button7 As Button
	Dim Button8 As Button
	Dim Button9 As Button
	Dim ButtonOK As Button
	Dim ButtonCE As Button
	Dim ButtonDec As Button
		
	Dim MessageDialog As Message
	Dim lblValue As Label
	Dim lblTitle As Label

End Sub

Sub Activity_Create(FirstTime As Boolean)

	If FirstTime Then
		'clicker.Initialize
		Main.phone1.SetScreenBrightness( Main.cfgBrightness )
	End If

	Activity.LoadLayout("keypad")
	
	If Activity.Width < Activity.height Then
		lblTitle.Gravity = Bit.OR(Gravity.LEFT, Gravity.CENTER_VERTICAL)	
	Else
		lblTitle.Gravity = Bit.OR(Gravity.CENTER_HORIZONTAL, Gravity.CENTER_VERTICAL)	
	End If
	
	MessageDialog.Initialize( "MessageDialog", 18, 14, 100%x,100%y)
	Activity.AddView(MessageDialog.AsView,0,0,100%x,100%y)

End Sub

Sub Activity_Resume

	lblTitle.Text = Main.strKeyPadTitle

	If Main.strKeyPadValue <> "0" Then
		lblValue.Text = Main.strKeyPadValue
	Else
		lblValue.Text = ""
	End If

	If lblValue.Text.IndexOf(".") < 0 Then
		DecimalUsed = False
	Else
		DecimalUsed = True
	End If
	
	CheckDecimal

End Sub

Sub Activity_Pause (UserClosed As Boolean)

	If lblValue.Text <> "" Then
		Main.strKeyPadValue = lblValue.Text
	End If

End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean                     
   If KeyCode = KeyCodes.KEYCODE_BACK Then
      Return True
   Else
      Return False
   End If
End Sub

Sub Button0_Click

	AddDigitIfPossible( "0" )

End Sub
Sub Button1_Click

	AddDigitIfPossible( "1" )

End Sub
Sub Button2_Click

	AddDigitIfPossible( "2" )

End Sub
Sub Button3_Click

	AddDigitIfPossible( "3" )

End Sub
Sub Button4_Click

	AddDigitIfPossible( "4" )

End Sub
Sub Button5_Click

	AddDigitIfPossible( "5" )

End Sub
Sub Button6_Click

	AddDigitIfPossible( "6" )

End Sub
Sub Button7_Click

	AddDigitIfPossible( "7" )

End Sub
Sub Button8_Click

	AddDigitIfPossible( "8" )

End Sub
Sub Button9_Click

	AddDigitIfPossible( "9" )

End Sub
Sub ButtonDec_Click

	AddDigitIfPossible( "." )

End Sub

Sub ButtonCE_Click

	If lblValue.Text.Length > 0 Then
		lblValue.Text = lblValue.Text.SubString2( 0, lblValue.Text.Length - 1)
		CheckDecimal
	End If
	
End Sub

Sub ButtonOK_Click
	
	If IsNumber( lblValue.text ) Then
		If lblValue.Text <= Main.intKeyPadMax AND lblValue.Text >= Main.intKeyPadMin Then

			If Main.intKeyPadDec = 1 Then
				If lblValue.Text = "0" OR lblValue.Text = "" OR lblValue.Text = "." Then
					lblValue.Text = "0"
				Else If lblValue.Text.IndexOf(".") = 0 Then
					lblValue.Text = "0" & lblValue.Text
				Else If lblValue.Text.IndexOf(".") = - 1 Then
					lblValue.Text = lblValue.Text & ".0"
				Else If lblValue.Text.IndexOf(".") = lblValue.Text.Length - 1 Then
					lblValue.Text = lblValue.Text & "0"
				End If
				If lblValue.Text.CharAt(0) = "0" AND lblValue.Text.length > 2 AND lblValue.Text.IndexOf(".") > 1 Then
					lblValue.Text = lblValue.Text.substring(1)
				End If
				If lblValue.Text.CharAt(0) = "0" AND lblValue.Text.length > 2 AND lblValue.Text.IndexOf(".") > 1 Then
					lblValue.Text = lblValue.Text.substring(1)
				End If
				If lblValue.Text = "0.0" Then
					lblValue.Text = "0"
				End If
			Else
				If lblValue.Text.CharAt(0) = "0" AND lblValue.Text.length > 1 Then
					lblValue.Text = lblValue.Text.substring(1)
				End If
				If lblValue.Text.CharAt(0) = "0" AND lblValue.Text.length > 1 Then
					lblValue.Text = lblValue.Text.substring(1)
				End If
			End If
			Main.intKeyPadMin = 0
			Main.intKeyPadMax = 999
			Main.strKeyPadValue = lblValue.text
			Main.intKeyPadDec = 0
			Activity.Finish
		Else
			MessageDialog.Show("Range Error", Main.strKeyPadTitle & " must be from " & Main.intKeyPadMin & " to " & Main.intKeyPadMax & " ", "Ok", "", "", 0, 0, 1.0 )
		End If
	Else
		Main.strKeyPadValue = "0"
		Main.strKeyPadTitle = ""
		Activity.Finish
	End If

End Sub

Sub AddDigitIfPossible( Digit As String )

	If lblValue.Text.Length < MaxNumLength + Main.intKeyPadDec Then
		If lblValue.Text.IndexOf(".") >= 0 AND lblValue.Text.IndexOf(".") = lblValue.Text.length - 2 Then
		Else
			lblValue.Text = lblValue.Text & Digit
			CheckDecimal
		End If
	End If

End Sub

Sub CheckDecimal

	If lblValue.Text.IndexOf(".") < 0 Then
		DecimalUsed = False
		If Main.intKeyPadDec = 0 Then
			ButtonDec.Enabled = False
		Else
			ButtonDec.Enabled = True
		End If
	Else
		DecimalUsed = True
		ButtonDec.Enabled = False
	End If

End Sub
